package com.robot.HomeCtrl;

import InternetDetect.ConnectionDetector;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
//import android.widget.TextView;
import android.widget.Toast;

public class HomeCtrlActivity extends Activity {
    /** Called when the activity is first created. */
	
    // flag for Internet connection status
    Boolean isInternetPresent = false;
 
    // Connection detector class
    ConnectionDetector cd;
	
	static DatabaseAdapter db;

	private EditText mIpText = null;
	private EditText mPortText = null;
	private EditText mIdText = null;
	private EditText mLoopSW= null;
	
	//private TextView buffshowId = null;
	
	private Button mButton = null;
	private Button ClrButton = null;
	private Button sButton= null;
	
	public String idSave = "0";
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        mIpText = (EditText) findViewById(R.id.IPText);
        mPortText = (EditText) findViewById(R.id.PortText);
        mIdText = (EditText) findViewById(R.id.editTextID);
        mLoopSW = (EditText) findViewById(R.id.mLoopSWALL);
        
        db = new DatabaseAdapter(this);
        db.close();
        
        db.open();
        Cursor c = db.getAllIPport();
        if(c.moveToFirst())
        {
        	do{
        		displayIPport(c);
        	}while(c.moveToNext());
        }
        
        db.close();
        
        mButton = (Button) findViewById(R.id.button01);
        ClrButton = (Button) findViewById(R.id.button02);
        sButton = (Button) findViewById(R.id.button03);
        
        // creating connection detector class instance
        cd = new ConnectionDetector(getApplicationContext());
 
        /**
         * Check Internet status button click event
         * */
        
        mButton.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
                // get Internet status
                isInternetPresent = cd.isConnectingToInternet();
 
                // check for Internet status
                if (isInternetPresent) {
                    // Internet Connection is Present
                    // make HTTP requests
                	
    				String ip = mIpText.getText().toString();
    				String port = mPortText.getText().toString();
    				
    				Intent connect = new Intent(HomeCtrlActivity.this, MainTab.class);
    				
    				connect.putExtra("sendIptext", ip);
    				connect.putExtra("sendPort", port);
    				
    				startActivity(connect);
    				
                    //showAlertDialog(HomeCtrlActivity.this, "Internet Connection",
                    //        "You have Internet connection", true);
                } else {
                    // Internet connection is not present
                    // Ask user to connect to Internet
                    showAlertDialog(HomeCtrlActivity.this, "!!! No Internet Connection",
                            "กรุณาเชื่อมต่อ Internet", false);
                }
			}
		});
        
        sButton.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
				String ip = mIpText.getText().toString();
				String port = mPortText.getText().toString();
				idSave = mIdText.getText().toString();
				
				db.open();
				
				if(!TextUtils.isEmpty(idSave))
				{
					db.deleteIPport(Integer.valueOf(idSave));
				}

				db.insertIPport(ip, port, "save IP and Port", "000");
				
				db.close();
				
				showAlertDialog(HomeCtrlActivity.this, "Save IP and Poer",
                        "บันทึก IP และ Port สำเร็จ", true);
				
				//Toast.makeText(getBaseContext(), "Save IP and Port Completed", Toast.LENGTH_SHORT).show();
			}
		});
        
        ClrButton.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
				idSave = mIdText.getText().toString();
				
				db.open();
				
				if(!TextUtils.isEmpty(idSave))
				{
					db.deleteIPport(Integer.valueOf(idSave));
				}
				
				db.close();
				
				Toast.makeText(getBaseContext(), "Delete IP and Port Completed", Toast.LENGTH_SHORT).show();
			}
		});
    }
    
	public void displayIPport(Cursor c){
		
        mIdText.append(c.getString(0));
        mIpText.append(c.getString(1));
        mPortText.append(c.getString(2));
        mLoopSW.append(c.getString(4));
        
    }
	
    /**
     * Function to display simple Alert Dialog
     * @param context - application context
     * @param title - alert dialog title
     * @param message - alert message
     * @param status - success/failure (used to set icon)
     * */
    public void showAlertDialog(Context context, String title, String message, Boolean status) {
        AlertDialog alertDialog = new AlertDialog.Builder(context).create();
 
        // Setting Dialog Title
        alertDialog.setTitle(title);
 
        // Setting Dialog Message
        alertDialog.setMessage(message);
 
        // Setting alert dialog icon
        //alertDialog.setIcon((status) ? R.drawable.success : R.drawable.fail);
 
        // Setting OK Button
        alertDialog.setButton("OK", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            }
        });
 
        // Showing Alert Message
        alertDialog.show();
    }
}