package com.robot.HomeCtrl;

import android.app.TabActivity;
import android.content.Intent;
import android.os.Bundle;
import android.widget.TabHost;
import android.widget.TabHost.TabSpec;

public class MainTab extends TabActivity{
	/** Called when the activity is first created. */
	private String fwshowIP;
	private String fwshowPort;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.maintab);
        
		fwshowIP = getIntent().getStringExtra("sendIptext");
		fwshowPort = getIntent().getStringExtra("sendPort");
		
        TabHost tabHost = getTabHost();
        
        // Tab for TCP Control
        TabSpec tcpspec = tabHost.newTabSpec("TCP Ctrl");
        tcpspec.setIndicator("TCP Ctrl", getResources().getDrawable(R.drawable.icon_tcpcontol_tab));
        Intent tcpctrlIntent = new Intent(this, TCPcontrol.class);
        
        tcpctrlIntent.putExtra("sendIptext", fwshowIP);
        tcpctrlIntent.putExtra("sendPort", fwshowPort);
        
        tcpspec.setContent(tcpctrlIntent);
        

        
        // Tab for Timer Control
        TabSpec timerspec = tabHost.newTabSpec("Timer Ctrl");
        timerspec.setIndicator("Timer Ctrl", getResources().getDrawable(R.drawable.icon_timercontrol_tab));
        Intent timerIntent = new Intent(this, TimerControl.class);
        
        timerIntent.putExtra("sendIptext", fwshowIP);
        timerIntent.putExtra("sendPort", fwshowPort);
        
        timerspec.setContent(timerIntent);
       
        
        // Tab for System Setting
        TabSpec settingspec = tabHost.newTabSpec("Sys Setting");
        settingspec.setIndicator("Sys Setting", getResources().getDrawable(R.drawable.icon_syssetting_tab));
        Intent settingIntent = new Intent(this, SystemSetting.class);
        settingspec.setContent(settingIntent);
        
        // Adding all TabSpec to TabHost
        tabHost.addTab(tcpspec); // Adding TCP Control tab
        tabHost.addTab(timerspec); // Adding Timer Control tab
        tabHost.addTab(settingspec); // Adding System Setting tab
    }

}
