package com.robot.HomeCtrl;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.Calendar;

import InternetDetect.ConnectionDetector;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.TimePicker;

public class TimerControl extends Activity {
	
	protected static final String DEBUG_TAG = null;
	private String showSWnum;
	private String LoopSW;
	private String showIP;
	private String showPort;
	
	private Socket socket = null;
	private String message = "$XPORTSETSW";
	private String AllOff= "$XPORTOFFALL************************************************************************************************************";
	
	private int mDate;
	private int mMonth;
	private int mYear;
	
	private int mDOW;
	private int mHour;
	private int mMinute;
	private int mSec;
	
	TimePicker mPickTimeSWON;
	TimePicker mPickTimeSWOFF ;
	
	static final int TIME_DIALOG_ID = 0;
	
	private TextView RTCview;
	private TextView SWNumberView;
	
    // flag for Internet connection status
    Boolean isInternetPresent = false;
 
    // Connection detector class
    ConnectionDetector cd;
    
    RadioButton RSW1, RSW2, RSW3, RSW4, RSW5, RSW6 ;
    CheckBox LoopCheck;
	
	private Handler handler = new Handler();
	
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.timer);    
        
        RSW1 = (RadioButton)findViewById(R.id.radio1);
        RSW2 = (RadioButton)findViewById(R.id.radio2);
        RSW3 = (RadioButton)findViewById(R.id.radio3);
        RSW4 = (RadioButton)findViewById(R.id.radio4);
        RSW5 = (RadioButton)findViewById(R.id.radio5);
        RSW6 = (RadioButton)findViewById(R.id.radio6);
        
		Button TimerSet = (Button) findViewById (R.id.buttonTimerSet);
		
		showIP = getIntent().getStringExtra("sendIptext");
		showPort = getIntent().getStringExtra("sendPort");
		
		RTCview = (TextView) findViewById(R.id.textViewRTC);
		
		mPickTimeSWON = (TimePicker) findViewById(R.id.timePicker1);
		mPickTimeSWOFF = (TimePicker) findViewById(R.id.timePicker2);
		
		mPickTimeSWON.setIs24HourView(true);
		mPickTimeSWOFF.setIs24HourView(true);
		
		final Calendar c = Calendar.getInstance();
		
		mDate = c.get(Calendar.DATE);
		mMonth = c.get(Calendar.MONTH);
		mYear = c.get(Calendar.YEAR);
				
		mDOW = c.get(Calendar.DAY_OF_WEEK);
		mHour = c.get(Calendar.HOUR_OF_DAY);
		mMinute = c.get(Calendar.MINUTE);
		mSec = c.get(Calendar.SECOND);
		
		mPickTimeSWON.setCurrentHour(mHour);
		mPickTimeSWOFF.setCurrentHour(mHour);
		
		showIP = getIntent().getStringExtra("sendIptext");
		showPort = getIntent().getStringExtra("sendPort");
		
		TextView IPView = (TextView) (TextView) findViewById(R.id.textView2);
		TextView PortView = (TextView) (TextView) findViewById(R.id.textView4);
		
		IPView.setText(showIP);
		PortView.setText(showPort);
		
		SWNumberView = (TextView) findViewById(R.id.textView10);
		LoopCheck =( CheckBox ) findViewById( R.id.checkBox1);
		
		TimerSet.setOnClickListener(new View.OnClickListener() {	
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub;
                	
				SyncRTC();
				
				try{
        			socket = new Socket(showIP,Integer.valueOf(showPort));
        			PrintWriter out = new PrintWriter(new BufferedWriter(
        			  new OutputStreamWriter(socket.getOutputStream())),true);
        			
        			out.println(AllOff);
        			
        			Thread.sleep(1000);
        			
        			out.println(RTCview.getText().toString());
        			
        			Thread.sleep(1000);
        			
        			showSWnum = CheckSW();
        			LoopSW = CheckLoopSW();
        			
        			out.println(message + showSWnum + ":ON:"
                			+ mPickTimeSWON.getCurrentHour() + ":"
                			+ mPickTimeSWON.getCurrentMinute()
                			+":OFF:" 
                			+ mPickTimeSWOFF.getCurrentHour() + ":"
                			+ mPickTimeSWOFF.getCurrentMinute() + ":"
                			+ LoopSW
                			+ ":*************************************************************************************************************");
                    
                    Thread TCPrev = new Thread(new TCPrevThread());
                    TCPrev.start();
                    
                    out.close();
                    socket.close();
                    
        		}catch (Exception e){
        			Log.e(DEBUG_TAG, e.toString());
        		}
        		  
	        }
		});   
    }
    
    private String CheckLoopSW(){
    	
    	String StCheckSW = null;
    	
    	if(LoopCheck.isChecked()){
    		StCheckSW = "1";
    	}
    	else{
    		StCheckSW = "0";
    	}
		return StCheckSW;
    	
    }
    
    private String CheckSW() {
    	
    	String SWnumber = null;
    	
	    	if(RSW1.isChecked())
	    	{
	    		SWnumber = "1";
	    	}
	    	else if(RSW2.isChecked())
	    	{
	    		SWnumber = "2";
	    	}
	    	else if(RSW3.isChecked())
	    	{
	    		SWnumber = "3";
	    	}
	    	else if(RSW4.isChecked())
	    	{
	    		SWnumber = "4";
	    	}
	    	else if(RSW5.isChecked())
	    	{
	    		SWnumber = "5";
	    	}
	    	else if(RSW6.isChecked())
	    	{
	    		SWnumber = "6";
	    	}
	    	
		SWNumberView.setText(new StringBuilder().append(SWnumber));	
		return SWnumber;

    }
    
	private void SyncRTC() {
		
		final Calendar c = Calendar.getInstance();
		
		mDate = c.get(Calendar.DATE);
		mMonth = c.get(Calendar.MONTH);
		mYear = c.get(Calendar.YEAR);
				
		mDOW = c.get(Calendar.DAY_OF_WEEK);
		mHour = c.get(Calendar.HOUR_OF_DAY);
		mMinute = c.get(Calendar.MINUTE);
		mSec = c.get(Calendar.SECOND);
		
		RTCview.setText(new StringBuilder()
		.append("$XPORTSYNRTC:")
		.append(mDate).append(":").append(pad(mMonth)).append(":").append(mYear).append(":").append(mDOW).append(":")
		.append(pad(mHour)).append(":")
		.append(pad(mMinute)).append(":").append(mSec)
		.append(":*****************************************************************************************"));
	}
	
	private static String pad(int c) {
		if (c >= 10)
		return String.valueOf(c);
		else
		return "0" + String.valueOf(c);
	}
	
	public class TCPrevThread implements Runnable {
		
		public void run(){
			
			try {
				//socket = new Socket(mIPView.getText().toString(),Integer.valueOf(showPort));
				
    			BufferedReader br = new BufferedReader(new InputStreamReader(socket.getInputStream()));
    			
    			String msg;
    			
    			
    			while((msg = br.readLine()) != null)
    			{
    				Log.d("Comming Msg: ", msg);
    				
    				// Do compare If Data coming in is correct data

    			}
    			
    			br.close();
    			
			} catch (IOException e) {
				// TODO Auto-generated catch block
	                handler.post(new Runnable() {
	                    @Override
	                    public void run() {
	        				
	            			// Do compare If Data coming in is correct data
	        				//Toast.makeText(getBaseContext(), "SET SW Timer Success", Toast.LENGTH_SHORT).show();
	                    	
	        				showAlertDialog(TimerControl.this, "Timer Setup Success",
	                                "คำสั่งควบคุมการตั้งเวลา สำเร็จ", true);
	                        
	                    }
	                });
				e.printStackTrace();
			}
		}
	}
	
    /**
     * Function to display simple Alert Dialog
     * @param context - application context
     * @param title - alert dialog title
     * @param message - alert message
     * @param status - success/failure (used to set icon)
     * */
    public void showAlertDialog(Context context, String title, String message, Boolean status) {
        AlertDialog alertDialog = new AlertDialog.Builder(context).create();
 
        // Setting Dialog Title
        alertDialog.setTitle(title);
 
        // Setting Dialog Message
        alertDialog.setMessage(message);
 
        // Setting alert dialog icon
        //alertDialog.setIcon((status) ? R.drawable.success : R.drawable.fail);
 
        // Setting OK Button
        alertDialog.setButton("OK", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            }
        });
 
        // Showing Alert Message
        alertDialog.show();
    }
}